QXmpp: QXmppAtmTrustStorage Class Reference

QXmpp Version: 1.14.3

Loading...
Searching...
No Matches
QXmppAtmTrustStorage Class Referenceabstract

The QXmppAtmTrustStorage class stores trust data for XEP-0450: Automatic Trust Management (ATM). More...

Inheritance diagram for QXmppAtmTrustStorage:

## Public Member Functions
virtual QXmppTask< void > | addKeysForPostponedTrustDecisions (const QString &encryption, const QByteArray &senderKeyId, const QList< QXmppTrustMessageKeyOwner > &keyOwners)=0
virtual QXmppTask< void > | removeKeysForPostponedTrustDecisions (const QString &encryption, const QList< QByteArray > &keyIdsForAuthentication, const QList< QByteArray > &keyIdsForDistrusting)=0
virtual QXmppTask< void > | removeKeysForPostponedTrustDecisions (const QString &encryption, const QList< QByteArray > &senderKeyIds)=0
virtual QXmppTask< void > | removeKeysForPostponedTrustDecisions (const QString &encryption)=0
virtual QXmppTask< QHash< bool, QMultiHash< QString, QByteArray > > > | keysForPostponedTrustDecisions (const QString &encryption, const QList< QByteArray > &senderKeyIds={})=0
Public Member Functions inherited from QXmppTrustStorage
virtual QXmppTask< void > | setSecurityPolicy (const QString &encryption, QXmpp::TrustSecurityPolicy securityPolicy)=0
virtual QXmppTask< void > | resetSecurityPolicy (const QString &encryption)=0
virtual QXmppTask< QXmpp::TrustSecurityPolicy > | securityPolicy (const QString &encryption)=0
virtual QXmppTask< void > | setOwnKey (const QString &encryption, const QByteArray &keyId)=0
virtual QXmppTask< void > | resetOwnKey (const QString &encryption)=0
virtual QXmppTask< QByteArray > | ownKey (const QString &encryption)=0
virtual QXmppTask< void > | addKeys (const QString &encryption, const QString &keyOwnerJid, const QList< QByteArray > &keyIds, QXmpp::TrustLevel trustLevel=QXmpp::TrustLevel::AutomaticallyDistrusted)=0
virtual QXmppTask< void > | removeKeys (const QString &encryption, const QList< QByteArray > &keyIds)=0
virtual QXmppTask< void > | removeKeys (const QString &encryption, const QString &keyOwnerJid)=0
virtual QXmppTask< void > | removeKeys (const QString &encryption)=0
virtual QXmppTask< QHash< QXmpp::TrustLevel, QMultiHash< QString, QByteArray > > > | keys (const QString &encryption, QXmpp::TrustLevels trustLevels={})=0
virtual QXmppTask< QHash< QString, QHash< QByteArray, QXmpp::TrustLevel > > > | keys (const QString &encryption, const QList< QString > &keyOwnerJids, QXmpp::TrustLevels trustLevels={})=0
virtual QXmppTask< bool > | hasKey (const QString &encryption, const QString &keyOwnerJid, QXmpp::TrustLevels trustLevels)=0
virtual QXmppTask< QHash< QString, QMultiHash< QString, QByteArray > > > | setTrustLevel (const QString &encryption, const QMultiHash< QString, QByteArray > &keyIds, QXmpp::TrustLevel trustLevel)=0
virtual QXmppTask< QHash< QString, QMultiHash< QString, QByteArray > > > | setTrustLevel (const QString &encryption, const QList< QString > &keyOwnerJids, QXmpp::TrustLevel oldTrustLevel, QXmpp::TrustLevel newTrustLevel)=0
virtual QXmppTask< QXmpp::TrustLevel > | trustLevel (const QString &encryption, const QString &keyOwnerJid, const QByteArray &keyId)=0
virtual QXmppTask< void > | resetAll (const QString &encryption)=0

## Detailed Description

The QXmppAtmTrustStorage class stores trust data for XEP-0450: Automatic Trust Management (ATM).

Since
  QXmpp 1.5

## Member Function Documentation

## ◆ addKeysForPostponedTrustDecisions()

virtual QXmppTask< void > QXmppAtmTrustStorage::addKeysForPostponedTrustDecisions | ( | const QString & | encryption,
|  | const QByteArray & | senderKeyId,
|  | const QList< QXmppTrustMessageKeyOwner > & | keyOwners )
| pure virtual

Adds keys that cannot be authenticated or distrusted directly because the key of the trust message's sender is not yet authenticated.

Those keys are being authenticated or distrusted once the sender's key is authenticated. Each element of keyOwners (i.e., keyOwner) can contain keys for postponed authentication as trustedKeys or for postponed distrusting as distrustedKeys.

If keys of keyOwner.trustedKeys() are already stored for postponed distrusting, they are changed to be used for postponed authentication. If keys of keyOwner.distrustedKeys() are already stored for postponed authentication, they are changed to be used for postponed distrusting. If the same keys are in keyOwner.trustedKeys() and keyOwner.distrustedKeys(), they are used for postponed distrusting.

Parameters

  encryption | encryption protocol namespace
  senderKeyId | key ID of the trust message's sender
  keyOwners | key owners containing key IDs for postponed trust decisions

## ◆ keysForPostponedTrustDecisions()

virtual QXmppTask< QHash< bool, QMultiHash< QString, QByteArray > > > QXmppAtmTrustStorage::keysForPostponedTrustDecisions | ( | const QString & | encryption,
|  | const QList< QByteArray > & | senderKeyIds = {} )
| pure virtual

Returns the JIDs of key owners mapped to the IDs of their keys stored for postponed authentication (true) or postponed distrusting (false).

If senderKeyIds is empty, all keys for encryption are returned.

Parameters

  encryption | encryption protocol namespace
  senderKeyIds | key IDs of the trust messages' senders

Returns
  the key owner JIDs mapped to their keys

## ◆ removeKeysForPostponedTrustDecisions() [1/3]

virtual QXmppTask< void > QXmppAtmTrustStorage::removeKeysForPostponedTrustDecisions | ( | const QString & | encryption | ) |
| pure virtual

Removes all keys for postponed authentication or distrusting for encryption.

Parameters

  encryption | encryption protocol namespace

## ◆ removeKeysForPostponedTrustDecisions() [2/3]

virtual QXmppTask< void > QXmppAtmTrustStorage::removeKeysForPostponedTrustDecisions | ( | const QString & | encryption,
|  | const QList< QByteArray > & | keyIdsForAuthentication,
|  | const QList< QByteArray > & | keyIdsForDistrusting )
| pure virtual

Removes keys for postponed authentication or distrusting.

Parameters

  encryption | encryption protocol namespace
  keyIdsForAuthentication | IDs of the keys for postponed authentication
  keyIdsForDistrusting | IDs of the keys for postponed distrusting

## ◆ removeKeysForPostponedTrustDecisions() [3/3]

virtual QXmppTask< void > QXmppAtmTrustStorage::removeKeysForPostponedTrustDecisions | ( | const QString & | encryption,
|  | const QList< QByteArray > & | senderKeyIds )
| pure virtual

Removes keys for postponed authentication or distrusting by the trust message sender's key ID.

Parameters

  encryption | encryption protocol namespace
  senderKeyIds | key IDs of the trust messages' senders

The documentation for this class was generated from the following files:

- QXmppAtmTrustStorage.h
- QXmppAtmTrustStorage.cpp